## minignumeric 0.5.0-2

=== debian/changelog ===
minignumeric (0.5.0-2) unstable; urgency=low

  * Some packaging fixes

 -- Tomasz Pieniazek <t.pieniazek@gazeta.pl>  Mon,  5 Jul 2010 23:18:58 +0200

minignumeric (0.5.0-1) unstable; urgency=low

  * Initial release

 -- Tomasz Pieniazek <t.pieniazek@gazeta.pl>  Sun,  4 Jul 2010 12:43:39 +0200
ncy=low
