=== debian/rules ===
#! /usr/bin/make -f
# Based on the sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.

#DEB_BUILD_OPTIONS?="debug nostrip"
export DEB_BUILD_OPTIONS

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE),m68k-linux)
	DEB_BUILD_OPTIONS+=noopt
endif

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=5

# Try to preserve timestamps as much as possible
export INSTALL=/usr/bin/install -p

# Are we building a release version, or are we doing development?
CVS_BUILD=$(shell test ! -d CVS; echo $$?)

upstreamversion=$(shell dpkg-parsechangelog | grep Version | head -1 | sed -e 's/Version: //g' -e 's/-[A-Za-z0-9+\.]*$$//g')

# Features configuration
# ---------------------- 
#
# We're aiming for a package that's stable, with as much functionality as is
# reasonably possible.

features:=

# Spreadsheet indexer for beagle
features+= --disable-ssindex

# Plugins to access databases through the GDA framework and through GnomeDB.
#
# The GDA and GnomeDB plugins for gnumeric now require versions of GDA and
# GnomeDB that are not available as packages yet.
#	Mon, 10 Oct 2005 20:37:06 +0200
features+= --without-gda --without-gnomedb

# configure.in: "Gnome Basic is extremely API unstable; it is likely that
# gnumeric will only build with the single version mentioned in
# configure.in, if at all. It is possible, but unlikely, that Gnome Basic
# contains security vulnerabilities."
features+= --without-gb

# Psion files support
features+= --without-psiconv

# Paradox database files plugin
features+= --without-paradox

# Perl plugin
features+= --without-perl

# The Python plugin
features+= --without-python

# Bonobo allows us to use parts of other applications as components via
# CORBA, and was supposed to allow us to work as a component for other
# applications. However, that promise hasn't really been realised and
# according to Morten Welinder "drop bonobo from your build.  it's
# pointless."
features+= --without-bonobo

# Don't build a PDF of the documentation.
features+= --disable-pdfdocs

# Build for Maemo/Hildon
features+= --enable-hildon

## Enable it for my development tree:
#features+= --enable-pdfdocs

confflags :=	--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--sysconfdir=/etc \
		--localstatedir=/var/lib \
		--libexecdir=/usr/bin \
                --enable-compile-warnings=minimum \
		$(features)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build $(DEB_HOST_GNU_TYPE)
else
	confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
        CFLAGS += -O0
else
        CFLAGS += -O2
endif

# Make the linker work a bit harder so dynamic loading can be done faster.
LDFLAGS += -Wl,-O1

# Make the linker only include actual dependencies on libraries, rather than
# for all libraries specified in the link line.
LDFLAGS += -Wl,--as-needed

source-updates:
	rm -f configure-stamp
	# Update files generated by autotools
	env srcdir=`pwd` NOCONFIGURE=1 \
		LIBTOOLIZE="libtoolize --copy" \
		INTLTOOLIZE="intltoolize --copy" \
		sh autogen.sh $(confflags)

configure: configure-stamp
configure-stamp:
	dh_testdir

	# Prepare for build
	 
	mkdir build
	cd build && env srcdir=`pwd`/.. \
		../configure $(confflags) "CC=$(CC) $(LDFLAGS)" "CFLAGS=$(CFLAGS)"

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	cd build && $(MAKE)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp debian/*substvars debian/*~ \
		debian/buildinfo

	rm -rf debian/tmp build

	# Update config.{sub,guess} from autotools-dev, if possible.
	-for f in config.sub config.guess ; do \
		if test -r /usr/share/misc/$$f ; then \
			OLDDATE=`./$$f -t | tr -d -` ; \
			NEWDATE=`/usr/share/misc/$$f -t | tr -d -` ; \
			if [ $$OLDDATE -lt $$NEWDATE ] ; then \
				echo "GNU config automated update of $$f (replacing $$OLDDATE with $$NEWDATE)" 1>&2 ; \
				cp -f /usr/share/misc/$$f $$f ; \
			fi; \
		fi; \
	done

	-find -type f -name 'Makefile.in' | sed -e 's/\.in$$//' | xargs rm -f
	-rm -f po/*.gmo

	# Clean out files generated as part of the documentation generation
	-rm -f doc/C/index.html doc/C/gnumeric.html doc/C/ld-id*.html \
		omf-install/gnumeric-C.omf
	-rm -rf doc/C/gnumeric doc/C/DBTOHTML_OUTPUT_DIR*

	-rm -rf aclocal.m4 config.h.in stamp-h.in autom4te.cache \
		doc/C/gnumeric.junk

	-rm -f GNOME_Gnumeric.server.in GNOME_Gnumeric.server src/gnumeric-paths.h

	dh_clean

install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	cd build && env GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1 \
		$(MAKE) install \
		DESTDIR=`pwd`/../debian/tmp/ \
		localstatedir=`pwd`/../debian/tmp/var/lib \
		libexecdir=`pwd`/../debian/tmp/usr/bin \
		scrollkeeper_localstate_dir=/var/lib/scrollkeeper

	# Plugins are not intended as stand-alone executables
	find `pwd`/debian/tmp/usr/lib/gnumeric/*/plugins -type f -print0 | xargs -0 chmod a-x

	# Remove unwanted files: static libraries and documentation sources
	find `pwd`/debian/tmp/usr/ -name '*.a' -print0 | xargs -0 rm -f
	find `pwd`/debian/tmp/ -name '*.sgml' -print0 | xargs -0 rm -f
	# Bonobo-only files
	rm -rf debian/tmp/usr/lib/bonobo
	# libspreadsheet is far from a mature library; loose the development
	# files
	rm -f debian/tmp/usr/lib/libspreadsheet*.la
	rm -f debian/tmp/usr/lib/pkgconfig/libspreadsheet-*.pc
	rm -rf debian/tmp/usr/include/libspreadsheet-*

	# Outdated
	rm -f debian/tmp/usr/share/mc/templates/gnumeric.desktop

	# Remove scrollkeeper generated files as well; for a package they
	# need to be (re)generated at package (de)install time.
	rm -rf `pwd`/debian/tmp/var/lib/scrollkeeper

	# Low-colour icon for use by the menu system
	#$(INSTALL) -m 644 debian/gnome-gnumeric.xpm `pwd`/debian/tmp/usr/share/pixmaps/

	# Checksums of historical versions of conffiles
	$(INSTALL) -m 644 debian/gnumeric-dialogs.schemas.md5sum debian/gnumeric-general.schemas.md5sum debian/gnumeric-plugins.schemas.md5sum `pwd`/debian/tmp/usr/share/gnumeric/

	dh_install --sourcedir=`pwd`/debian/tmp

	# Some fixes
	#cp -r debian/tmp/usr debian/minignumeric

	# Name the binary just "gnumeric"
	cd debian/minignumeric/usr/bin && mv gnumeric-* gnumeric

	#dh_link usr/share/gnumeric/$(upstreamversion)/idl/GNOME_Gnumeric.idl usr/share/idl/GNOME_Gnumeric.idl

	# Make the documentation accessible to gnumeric
	#dh_link -pgnumeric-doc usr/share/gnome/help/gnumeric usr/share/gnumeric/$(upstreamversion)/doc

	#dh_link -pgnumeric-doc usr/share/xml/docbook/stylesheet/nwalsh/images/ usr/share/gnumeric/$(upstreamversion)/doc/C/images

	# Remove files from the main package that belong to a more
	# specialist package
	# (dh_install doesn't do the right thing here IMO; perhaps it
	# doesn't like multiple globs in one line)
	#while read l ; do \
	#	rm -rvf debian/gnumeric/$$l ; \
	#done < debian/gnumeric-plugins-extra.install

	# Remove dirs that are now empty
	-find debian/minignumeric -depth -type d | xargs rmdir >/dev/null 2>&1

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdebconf -i
	dh_installdocs -i

	dh_installexamples -i
#	dh_pycentral -i
	#dh_python -i
#	dh_installmenu -i
#	dh_installlogrotate -i
#	dh_installemacsen -i
#	dh_installpam -i
	dh_installmime -i
#	dh_installinit -i
	dh_installcron -i
#	dh_installman -i
	dh_link -i
	dh_installinfo -i
#	dh_undocumented -i
	dh_installchangelogs ChangeLog -i
	dh_gconf -i
	dh_scrollkeeper -i
	dh_desktop -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
#	dh_perl -i
	dh_gencontrol -v -i -- -VUpstream-Version=$(upstreamversion)
	dh_md5sums -i
	dh_builddeb -i
